"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bodyParser = require("body-parser");
const cors = require("cors");
const express = require("express");
const requireAll = require("require-all");
const config_1 = require("./config/config");
class App {
    constructor(config = {}) {
        App.config = Object.assign(App.config, config);
        this.SetConfig();
    }
    Init() {
        requireAll({
            dirname: process.cwd() + `/${App.config.compiledPath}/controllers`,
            filter: /.+\.js$/,
            recursive: true
        });
        return App.expressApp;
    }
    SetConfig() {
        App.expressApp.set("baseRoute", App.config.baseRoute);
        if (App.config.bodyParserEnabled)
            App.expressApp.use(bodyParser.json());
        if (App.config.corsEnabled)
            App.expressApp.use(cors({
                exposedHeaders: App.config.exposedHeaders
            }));
        if (App.config.serverRenderingEnabled) {
            App.expressApp.use(express.static('./views'));
            App.expressApp.set('views', './views');
            App.expressApp.set('view engine', App.config.serverRenderingEngine);
        }
    }
    Configure(callback) {
        callback(App.expressApp);
    }
    get express() {
        return App.expressApp;
    }
}
App.expressApp = express();
App.config = new config_1.Config();
exports.App = App;
//# sourceMappingURL=app.js.map