"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = require("fs-extra");
const DirectoryNotFoundException_1 = require("../exceptions/DirectoryNotFoundException");
class FileSystemFacade {
    static GetDirData(path, recursive) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.IsDir(path))
                throw new DirectoryNotFoundException_1.DirectoryNotFoundException();
            try {
                (yield fs_extra_1.readdir(path)).forEach((item) => {
                    this._dirData.push({
                        directory: path,
                        files: item
                    });
                });
            }
            catch (e) {
                throw new DirectoryNotFoundException_1.DirectoryNotFoundException();
            }
            return this._dirData;
        });
    }
    static IsDir(content) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield fs_extra_1.lstat(content)).isDirectory();
        });
    }
}
FileSystemFacade._dirData = [];
exports.FileSystemFacade = FileSystemFacade;
//# sourceMappingURL=FileSystemFacade.js.map