"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jwt = require("jsonwebtoken");
const index_1 = require("../index");
function Auth() {
    return function (target, propertyKey, descriptor) {
        const rotaOriginal = descriptor.value;
        descriptor.value = function (req, res, next) {
            let token = req.headers['x-access-token'];
            if (!token)
                return res.status(401).send("Not authorized");
            return jwt.verify(token.toString(), index_1.App.config.secret, (err, decoded) => {
                if (err)
                    return res.status(401).send("Not authorized");
                return rotaOriginal.apply(this, [req, res, decoded]);
            });
        };
        return descriptor;
    };
}
exports.Auth = Auth;
//# sourceMappingURL=Auth.js.map