import { IPromiseFileSystem } from '../interfaces/IPromiseFileSystem';
import { lstat, readdir } from 'fs-extra';
import { DirectoryNotFoundException } from '../exceptions/DirectoryNotFoundException';


export class FileSystemFacade​​ {

    private static _dirData: IPromiseFileSystem[] = [];

    public static async GetDirData(path: string, recursive?: boolean) : Promise<IPromiseFileSystem[]> {
        
        if(this.IsDir(path)) throw new DirectoryNotFoundException();

        try {
            (await readdir(path)).forEach((item : string) => {
                this._dirData.push({
                    directory: path,
                    files: item
                })
            });
        } catch (e) {
            throw new DirectoryNotFoundException();
        }

        return this._dirData;
    }

    public static async IsDir(content: string): Promise<boolean> {
        return (await lstat(content)).isDirectory();
    }

}
