import { IControllerRoute } from '../core/interfaces/IControllerRoute';


export function Controller​​(baseRoute?: string|RegExp): Function {

    return (target: any): void => {
        const original: any = target.prototype;

        original.routes = <IControllerRoute[]>Object.getOwnPropertyNames(original)
            .filter((property: string) => property.indexOf('$$route__'))
            .map((property: string) => {

                const { method, path } = original[property];
                
                const mountpath:string = `${baseRoute}`;
                const fnName:string = property.substring('$$route__'.length);
                const route: IControllerRoute = { method, mountpath, path, fnName };;

                return route;
            })
    }
}