import 'reflect-metadata'
import { Exception } from '../core/exceptions/Exception';

function Http(method: string, path: string|RegExp) {
	if (typeof method !== 'string')
    throw new Exception('Argument method must an HTTP Verb');

  return (target:any, propertyKey:string, descriptor:PropertyDescriptor): void => {
      target[`$$route__${propertyKey}`] = { method, path };
  }

}

export const Get: Function = Http.bind(null, 'get');
export const Post: Function = Http.bind(null, 'post');
export const Put: Function = Http.bind(null, 'put');
export const Delete: Function = Http.bind(null, 'delete');